class ClickWriter():
    def __init__(self, filename):
        self.filename = filename
        self.fh = None

    def open(self):
        self.fh = open(self.filename, "w")

    def close(self):
        self.fh.close()

    def write_elements(self, elements, comment):
        self.fh.write("// %s\n" % comment)

        for element in elements:
            #if element['declaration']:
            #    self.fh.write(element['declaration'])
            self.fh.write(element)
            self.fh.write('\n')
        self.fh.write('\n')

    def write_pipelines(self, pipelines, comment):
        if comment != "":
            self.fh.write("// %s\n" % comment)

        for pipeline in pipelines:
            self.fh.write(pipeline)
            self.fh.write('\n')

        self.fh.write('\n')

    def write_comment(self, comment):
        self.fh.write("// %s\n\n" % comment)
