import networkx as nx
from . import obj

def find_input_port(g: nx.Graph, out_node: str, in_node: str, make_order=False):
    in_gnode = g.nodes[in_node]
    order = []

    print("in_node={}  out_node={} in_degree={}   in_edges={}".format(
        in_node,
        out_node,
        g.in_degree(in_node),
        g.in_edges(in_node),
    ))
    print(in_gnode)
    print(in_gnode['info'].__dict__)

    if g.in_degree(in_node) <= 1:
        return 0

    if hasattr(in_gnode['info'], "in_order") and in_gnode['info'].in_order:
        if not make_order:
            return 0

        if in_gnode['info'].inputs:
            order = in_gnode['info'].inputs.values()
        else:
            return 0
    else:
        order = in_gnode['info'].in_order

    port = list(order).index(out_node)
    return port

def find_output_port(g: nx.Graph, in_node, out_node, make_order=False):
    out_gnode = g.nodes[out_node]
    order = []

    print("in_node={}  out_node={} in_degree={}   in_edges={}".format(
        in_node,
        out_node,
        g.in_degree(in_node),
        g.in_edges(in_node),
    ))
    print(out_gnode)
    print(out_gnode['info'].__dict__)

    if g.out_degree(out_node) <= 1:
        return 0

    if not out_gnode['info'].out_order:
        if not out_gnode.order:
            if not make_order:
                return -1

            if out_gnode['info'].outputs:
                # This will be wrong if key orders are not the same between in_gnode and
                # out_gnode
                order = out_gnode['info'].outputs.values()
            else:
                return -1
        else:
            order = out_gnode['info'].order
    else:
        order = out_gnode['info'].out_order

    port = list(order).index(in_node)
    return port

def is_virtual_output(node, info):
    return (
        isinstance(info, obj.Interface) and
        info.virtual and
        "output" in node
    )
