from abc import ABC, abstractmethod

class Communicator(ABC):

    @abstractmethod
    def get_value(self, node, key):
        pass

    @abstractmethod
    def set_value(self, node, key, value):
        pass

class Manager(ABC):

    @abstractmethod
    def get_communicator(self):
        pass

    @abstractmethod
    def set_emulation(self, emulation, graph):
        pass

    @abstractmethod
    def create_emulation(self):
        pass

    @abstractmethod
    def start_emulation(self):
        pass

    @abstractmethod
    def stop_emulation(self):
        pass
