MOA_EMU_ERRS = {
    'NEW_EMU':      {'errno': 1,
                     'err_str': "Failed to Create New Emulation"},
    'ALLOC_CPU':    {'errno': 2,
                     'err_str': "Unable to allocate CPUs"},
    'EMU_START':    {'errno': 3,
                     'err_str': "Unable to start emulation process"},
    'EMU_STOP':     {'errno': 4,
                     'err_str': "Unable to stop emulation process"},
    'EMU_UPDATE':   {'errno': 5,
                     'err_str': "Unable to update emulation process"},
    'EMU_OBJ':      {'errno': 6,
                     'err_str': "Missing emulation object"},
    'EMU_CONFIG':   {'errno': 7,
                     'err_str': "Missing emulation configuration file"},
    'IFACE_UPDATE': {'errno': 9,
                     'err_str': "Unable to update Interfaces"},
    'ADD_VXLAN':    {'errno': 10,
                     'err_str': "Unable to add VXLAN to interface"},
    'REM_VXLAN':    {'errno': 11,
                     'err_str': "Unable to remove VXLAN to interface"},
    'EMU_CREATE':   {'errno': 12,
                     'err_str': "Unable to create Emulation Configuration"},
    'ADD_TO_EMU':   {'errno': 13,
                     'err_str': "Unable to add additional elements to emulation"}}

class MoaTestError(Exception):
    def __init__(self, except_type, test):
        self.except_type = except_type
        self.test = test
        super().__init__()

    def __str__(self):
        return "Moa Test Error: %s: %s Test Failed" % (self.except_type, self.test)

class MoaInputError(Exception):
    def __init__(self, iput, msg):
        self.iput = iput
        self.msg = msg
        super().__init__()

    def __str__(self):
        return "Moa Input Error: %s - %s" % (self.iput, self.msg)

class MoaEmulationError(Exception):
    def __init__(self, msg):
        self.msg = msg
        super().__init__()

    def __str__(self):
        return "Moa Emulation Error: %s" % (self.msg)
